/***************************************************************************/
/*** ERMA-Electronic GmbH, Max-Eyth-Str. 8, 78194 Immendingen            ***/
/*** Telefon: 07462/7381, Fax: 07462/7554                                ***/
/*** Programmname: FR1215F.C                                             ***/
/*** Testprogramm fr die PC-Karte FR 1215 als Frequenzmesser            ***/
/*** Programmiersprache: Turbo C++ Version 3.0                           ***/
/***************************************************************************/

#include <stdio.h>
#include <dos.h>
#include <conio.h>

void WerteSetzen();			//Adressen der Zhler zuweisen
void Bildschirm();			//Bilsdschirmmaske aufbauen
void Init1();				//Zhler initialisieren
void Nullsetzen();			//Zhler fr Frequenzmessung auf Null setzen
void Messung();				//Frequenzmessung
void Show();				//Frequenzen anzeigen

typedef int intarray[3];
//Basisadresse der Karte 0x100
//Adressen der einzelnen Zhler 00 bis 33
intarray Z[4]={0x100+0,0x100+1,0x100+2,
			   0x100+4,0x100+5,0x100+6,
			   0x100+8,0x100+9,0x100+10,
			   0x100+12,0x100+13,0x100+14};
//Adressen der Controll-Worte der Zhlerbausteine
int Z_CW[4]={0x100+3,0x100+7,
			 0x100+11,0x100+15};
int Teiler2=1000;
int Teiler1=2000;
int Zaehler[9];
int FREQ[9];
int LO,HI;
char ch;

void main()
{
	WerteSetzen();		//Adressen der Zhler zuweisen
	Bildschirm();		//Bildschirmmaske aufbauen
	Init1();			//Zhler initialisieren
	do
	{
		Nullsetzen();	//Zhler fr Frequenzmessung auf Null setzen
		gotoxy(27,7);
		cprintf("Messen  ");
		Messung();		//Frequenzmessung
		gotoxy(27,7);
		cprintf("Anzeigen");
		Show();			//Frequenzen anzeigen
		delay(100);
		if (kbhit())
		{
			ch=getch();
		}
	//Taste 'q' oder 'Q' = Programmende
	}while (ch!=('q') & ch!=('Q'));
	clrscr();
}

//Adressen der Zhler zuweisen
void WerteSetzen()
{
	//Basisadrsse der Zhler fr Frequenzmessung zuweisen
	Zaehler[0]=Z[1] [0];
	Zaehler[1]=Z[1] [1];
	Zaehler[2]=Z[1] [2];
	Zaehler[3]=Z[2] [0];
	Zaehler[4]=Z[2] [1];
	Zaehler[5]=Z[3] [2];
	Zaehler[6]=Z[3] [0];
	Zaehler[7]=Z[3] [1];
	Zaehler[8]=Z[3] [2];
}

//Bildschirmmaske aufbauen
void Bildschirm()
{
	int i;

	clrscr();
	gotoxy(33,4);
	cprintf("Frequenzmessung");
	gotoxy(6,5);
	cprintf("---------------------------------------------------------------------");
	gotoxy(34,23);
	cprintf("Ende mit <q>");
	for (i=0;i<=8;i++)
	{
		gotoxy(27,10+i);
		cprintf("Wert %d                  Hz", i);
	}
}

//Zhler initialisiern
void Init1()
{
	//Zhler 2 von Zhlerbaustein 0 = Mode 3
	outportb(Z_CW[0],0xB6);
	HI=div (Teiler1,256);
	LO=(Teiler1 % 256);
	//Zhler 2 von Zhlerbaustein 0 mit 2000 beschreiben => Messfrequenz
	outportb(Z[0] [2],LO);
	outportb(Z[0] [2],HI);
	//Zhler 1 von Zhlerbaustein 0 = Mode 1
	outportb(Z_CW[0],0x72);
	HI=div (Teiler2,256);
	LO=(Teiler2 % 256);
	//Zhler 1 von Zhlerbaustein 0 mit 1000 beschreiben => Zeitbasis
	outportb(Z[0] [1],LO);
	outportb(Z[0] [1],HI);
	//Zhler 0 von Zhlerbaustein 0 = Mode 4
	outportb(Z_CW[0],0x18);
}

//Zhler fr Frequenzmessung auf Null setzen
void Nullsetzen()
{
	int i;
	int n;
	int Z_CW_SP[3]={0x30,0x70,0xB0};

	for (i=1;i<=3;i++)
	{
		for (n=0;n<=2;n++)
		{
			outportb(Z_CW[i],Z_CW_SP[n]);
			outportb(Z[i] [n],0x0);
			outportb(Z[i] [n],0x0);
		}
	}
}

//Frequenzmessung
void Messung()
{
	int i;

	//Zhler 0 von Zhlerbaustein 0 mit 0x02 beschreiben => Triggerimpuls
	outportb(Z[0] [0],0x02);
	do
	{
		//READ-BACK-COMMAND Zhler 1 von Zhlerbaustein 0
		outportb(Z_CW[0],0xE4);
	//Abfrage OUTPUT-Bit Zhler 1 von Zhlerbaustein 0
	}while ((inportb(Z[0] [1]) & 0x80));
	do
	{
		//READ-BACK-COMMAND Zhler 1 von Zhlerbaustein 0
		outportb(Z_CW[0],0xE4);
	//Abfrage OUTPUT-Bit Zhler 1 von Zhlerbaustein 0
	}while (!(inportb(Z[0] [1]) & 0x80));
	for (i=0;i<=8;i++)
	{
		//Zhlerstnde einlesen
		LO=inportb(Zaehler[i]);
		HI=inportb(Zaehler[i]);
		FREQ[i]=(LO ^ 0xFF)+(0xFF*(HI ^ 0xFF));
	}
}

//Fequenzen anzeigen
void Show()
{
	int i;

	for (i=0;i<=8;i++)
	{
		gotoxy(41,10+i);
		printf("%5d", FREQ[i]);
	}
}