program FR1215F;

(**********************************
 * Testprogramm zur Karte FR 1215 *
 *       als Frequenzmesser       *
 **********************************)

USES Crt;
TYPE    int_array = array [0..2] of integer;
CONST   adresse : integer = $100;
        Z       : array [0..3] of int_array =
                  (($100+0,$100+1,$100+2),
                   ($100+4,$100+5,$100+6),
                   ($100+8,$100+9,$100+10),
                   ($100+12,$100+13,$100+14));
        Z_CW    : array [0..3] of integer = ($100+3,$100+7,
                                             $100+11,$100+15);
        Teiler2 : integer = 1000;
        Teiler1 : integer = 2000;
VAR     Zaehler : array [0..8] of integer;
        i,n     : integer;
        FREQ    : array [0..8] of integer;
        LO,HI   : integer;
        STATUS  : integer;

procedure WerteSetzen;
begin
     Zaehler[0]:=Z[1] [0]; Zaehler[1]:=Z[1] [1]; Zaehler[2]:=Z[1] [2];
     Zaehler[3]:=Z[2] [0]; Zaehler[4]:=Z[2] [1]; Zaehler[5]:=Z[2] [2];
     Zaehler[6]:=Z[3] [0]; Zaehler[7]:=Z[3] [1]; Zaehler[8]:=Z[3] [2];
end;

procedure Bildschirm;
begin
     clrscr;
     gotoXY(11,4);write('Frequenzmessung');
     gotoXY(11,5);write('----------------------------------------------------------');
     gotoXY(41,23);write('Ende mit <q>');
     for i:=0 to 8 do begin
         gotoXY(10,10+i); write('Wert ',i,'                     Hz');
     end;
end;

procedure Init1;
begin
     Port[Z_CW[0]]:=$B6;
     HI:=Teiler1 div 256;
     LO:=Teiler1 mod 256;
     Port[Z[0] [2]]:=LO;
     Port[Z[0] [2]]:=HI;
     Port[Z_CW[0]]:=$72;
     HI:=Teiler2 div 256;
     LO:=Teiler2 mod 256;
     Port[Z[0] [1]]:=LO;
     Port[Z[0] [1]]:=HI;
     Port[Z_CW[0]]:=$18;
end;

procedure Nullsetzen;
const Z_CW_SP : array [0..2] of integer = ($30,$70,$B0);
begin
     for i:=1 to 3 do
         for n:=0 to 2 do begin
             Port[Z_CW[i]]:=Z_CW_SP[n];
             Port[Z[i] [n]]:=0;
             Port[Z[i] [n]]:=0;
         end;
end;

procedure Messung;
begin   { von hier ... }
     Port[Z[0] [0]]:=$02;
     Port[Z_CW[0]] :=$E4;
     STATUS:=Port[Z[0] [1]];
     { Warten bis Status gesetzt }
     while ((STATUS and $80) <>0) do begin
           Port[Z_CW[0]]:=$E4;
           STATUS:=Port[Z[0] [1]];
     end;
     { Warten bis Status  gelscht }
     while ((STATUS and $80) = 0) do begin
           Port[Z_CW[0]]:=$E4;
           STATUS:=Port[Z[0] [1]];
     end;                      { ... bis hier vergeht 1 sec }
     for i:=0 to 8 do begin    { nur noch Auslesen der Werte, die nach }
         LO:=Port[Zaehler[i]]; { dieser Sekunde im Zhler stehen       }
         HI:=Port[Zaehler[i]];
         FREQ[i]:=(LO xor $FF)+($FF*(HI xor $FF));
     end;
end;

procedure Show;
begin
     for i:=0 to 8 do begin
         gotoXY(24,10+i); write(FREQ[i]:5,'   ');
     end;
end;

BEGIN
     WerteSetzen;
     Bildschirm;
     Init1;
     repeat
           Nullsetzen;
           gotoXY(11,7);write('Messen  ');
           Messung;
           gotoXY(11,7);write('Anzeigen');
           delay(100);
           Show;
     until keypressed;
END.